'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Portal = require('react-portal/lib/Portal');

var _Portal2 = _interopRequireDefault(_Portal);

var _reactMotion = require('react-motion');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Mortal = function (_Component) {
  _inherits(Mortal, _Component);

  function Mortal() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Mortal);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Mortal.__proto__ || Object.getPrototypeOf(Mortal)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isPortalOpened: false,
      isVisible: false
    }, _this.handleKey = function (e) {
      var _this$props = _this.props,
          closeOnEsc = _this$props.closeOnEsc,
          onClose = _this$props.onClose;
      var isPortalOpened = _this.state.isPortalOpened;
      // handle ESC key

      if (e.which === 27 && isPortalOpened && closeOnEsc) {
        onClose();
      }
    }, _this.handleRest = function () {
      if (!_this.state.isVisible) {
        _this.setState({ isPortalOpened: false });
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Mortal, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      // if portal is created opened,
      // no animation is needed
      if (this.props.isOpened) {
        this.setState({
          isPortalOpened: true,
          isVisible: true
        });
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      window.addEventListener('keydown', this.handleKey);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var isOpened = this.props.isOpened;
      var _state = this.state,
          isVisible = _state.isVisible,
          isPortalOpened = _state.isPortalOpened;


      var willOpen = !isOpened && nextProps.isOpened;
      if (willOpen) {
        this.setState({ isPortalOpened: true });
      }

      var willClose = isOpened && !nextProps.isOpened;
      if (willClose) {
        this.setState({ isVisible: false });
      }

      var hasReopened = willOpen && !isVisible && isPortalOpened;
      if (hasReopened) {
        this.setState({ isVisible: true });
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      var _this2 = this;

      var didOpen = this.props.isOpened && !prevProps.isOpened;
      if (didOpen) {
        window.requestAnimationFrame(function () {
          if (_this2._unmounted) {
            return;
          }
          _this2.setState({ isVisible: true });
        });
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('keydown', this.handleKey);
      this._unmounted = true;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          motionStyle = _props.motionStyle,
          children = _props.children,
          portalProps = _props.portalProps;
      var _state2 = this.state,
          isPortalOpened = _state2.isPortalOpened,
          isVisible = _state2.isVisible;


      if (!isPortalOpened) {
        return null;
      }

      return _react2.default.createElement(
        _Portal2.default,
        portalProps,
        _react2.default.createElement(
          _reactMotion.Motion,
          { onRest: this.handleRest, style: motionStyle(_reactMotion.spring, isVisible) },
          function (motion) {
            return children(motion, isVisible);
          }
        )
      );
    }
  }]);

  return Mortal;
}(_react.Component);

Mortal.propTypes = {
  onClose: _propTypes2.default.func.isRequired,
  portalProps: _propTypes2.default.object,
  closeOnEsc: _propTypes2.default.bool
};
Mortal.defaultProps = {
  closeOnEsc: true
};
exports.default = Mortal;